package org.randombits.filtering.confluence.param.search.content;

import com.atlassian.confluence.search.service.ContentTypeEnum;
import com.atlassian.confluence.search.v2.query.ContentTypeQuery;
import org.randombits.filtering.confluence.param.search.BaseMultipleSearchQueryInterpreter;
import org.randombits.support.core.param.AbstractParameterInterpreter;
import org.randombits.support.core.param.InterpretationException;
import org.randombits.support.core.param.ParameterContext;

/**
 * Interprets a parameter String as a {@link ContentTypeQuery}.
 */
public class ContentTypeQueryInterpreter extends AbstractParameterInterpreter<ContentTypeQuery> {

    public static class Multiple extends BaseMultipleSearchQueryInterpreter<ContentTypeQueryInterpreter> {

        public Multiple() {
            super( new ContentTypeQueryInterpreter() );
        }
    }

    @Override
    public ContentTypeQuery interpret( String inputValue, ParameterContext context ) throws InterpretationException {
        return new ContentTypeQuery( findContentTypeEnum( inputValue ) );
    }

    private ContentTypeEnum findContentTypeEnum( String inputValue ) {
        return ContentTypeEnum.getByRepresentation( inputValue );
    }
}
